"me.danielzgtg.MediaAnimate" : {
    "environment" : {
        "framerate" = #30#,
        "duration" = #60#,
        "batchsize" = #15#,
    },
    "literals" : [
        $ stage grid start
        {
            "id" = "stagew",
            "type" = "integerliteral",
            "value" = #1920#,
        },
        {
            "id" = "stageh",
            "type" = "integerliteral",
            "value" = #1080#,
        },
        {
            "id" = "__tmp_gridlinex_0",
            "type" = "integerliteral",
            "value" = #4#,
        },
        {
            "id" = "__tmp_gridlinex_2",
            "type" = "integerliteral",
            "value" = #2#,
        },
        {
            "id" = "__tmp_gridlinex_3",
            "type" = "integerliteral",
            "value" = #3#,
        },
        {
            "id" = "gridx1",
            "type" = "integerbifunction",
            "func" = "/",
            "num1ref" = "stagew",
            "num2ref" = "__tmp_gridlinex_0",
        },
        {
            "id" = "gridx2",
            "type" = "integerbifunction",
            "func" = "*",
            "num1ref" = "gridx1",
            "num2ref" = "__tmp_gridlinex_2",
        },
        {
            "id" = "gridx3",
            "type" = "integerbifunction",
            "func" = "*",
            "num1ref" = "gridx1",
            "num2ref" = "__tmp_gridlinex_3",
        },
        {
            "id" = "__tmp_gridliney_0",
            "type" = "integerliteral",
            "value" = #4#,
        },
        {
            "id" = "__tmp_gridliney_2",
            "type" = "integerliteral",
            "value" = #2#,
        },
        {
            "id" = "__tmp_gridliney_3",
            "type" = "integerliteral",
            "value" = #3#,
        },
        {
            "id" = "gridy1",
            "type" = "integerbifunction",
            "func" = "/",
            "num1ref" = "stageh",
            "num2ref" = "__tmp_gridliney_0",
        },
        {
            "id" = "gridy2",
            "type" = "integerbifunction",
            "func" = "*",
            "num1ref" = "gridy1",
            "num2ref" = "__tmp_gridliney_2",
        },
        {
            "id" = "gridy3",
            "type" = "integerbifunction",
            "func" = "*",
            "num1ref" = "gridy1",
            "num2ref" = "__tmp_gridliney_3",
        },
        $ stage grid end
        $ size calcs start
        {
            "id" = "photon.w",
            "type" = "integerliteral",
            "value" = #193#,
        },
        {
            "id" = "photon.h",
            "type" = "integerliteral",
            "value" = #188#,
        },
        {
            "id" = "hphoton.w",
            "type" = "floatbifunction",
            "func" = "/",
            "num1ref" = "photon.w",
            "num2ref" = "two",
        },
        {
            "id" = "hphoton.h",
            "type" = "floatbifunction",
            "func" = "/",
            "num1ref" = "photon.h",
            "num2ref" = "two",
        },
        {
            "id" = "co2.w",
            "type" = "integerliteral",
            "value" = #193#,
        },
        {
            "id" = "co2.h",
            "type" = "integerliteral",
            "value" = #188#,
        },
        {
            "id" = "hco2.w",
            "type" = "floatbifunction",
            "func" = "/",
            "num1ref" = "co2.w",
            "num2ref" = "two",
        },
        {
            "id" = "hco2.h",
            "type" = "floatbifunction",
            "func" = "/",
            "num1ref" = "co2.h",
            "num2ref" = "two",
        },
        $ size calcs end
        $ grid snaps start
        {
            "id" = "s1co2.x",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridx1",
            "num2ref" = "hco2.w",
        },
        {
            "id" = "s1co2.y",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridy1",
            "num2ref" = "hco2.h",
        },
        {
            "id" = "s2co2.x",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridx1",
            "num2ref" = "hco2.w",
        },
        {
            "id" = "s2co2.y",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridy3",
            "num2ref" = "hco2.h",
        },
        {
            "id" = "s3co2.x",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridx2",
            "num2ref" = "hco2.w",
        },
        {
            "id" = "s3co2.y",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridy2",
            "num2ref" = "hco2.h",
        },
        {
            "id" = "s4co2.x",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridx3",
            "num2ref" = "hco2.w",
        },
        {
            "id" = "s4co2.y",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridy1",
            "num2ref" = "hco2.h",
        },
        {
            "id" = "s5co2.x",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridx3",
            "num2ref" = "hco2.w",
        },
        {
            "id" = "s5co2.y",
            "type" = "floatbifunction",
            "func" = "-",
            "num1ref" = "gridy3",
            "num2ref" = "hco2.h",
        },
        $ grid snaps end
        $ rotations start
        {
            "id" = "rotamplitude_deg",
            "type" = "integerliteral"
            "value" = #45#,
        },
        {
            "id" = "rotamplitude",
            "type" = "floatmonofunction",
            "func" = "radians()",
            "numref" = "rotamplitude_deg",
        },
        {
            "id" = "frequency",
            "type" = "integerliteral",
            "value" = #1#,
        },
        {
            "id" = "period",
            "type" = "floatbifunction",
            "func" = "/",
            "num1ref" = "fps",
            "num2ref" = "frequency",
        },
        {
            "id" = "radperiod",
            "type" = "floatbifunction",
            "func" = "*",
            "num1ref" = "period",
            "num2ref" = "2pi",
        },
        {
            "id" = "phaseoffset_photon",
            "type" = "integerliteral",
            "value" = #0#,
        },
        {
            "id" = "phaseoffset_co2",
            "type" = "integerliteral",
            "value" = #0#,
        },
        $ rotations end
        $ fades start
        {
            "id" = "bgfadein_end",
            "type" = "integerliteral",
            "value" = #15#,
        },
        {
            "id" = "co2fadein_start",
            "type" = "integerliteral",
            "value" = #30#,
        },
        {
            "id" = "co2fadein_end",
            "type" = "integerliteral",
            "value" = #60#,
        },
        {
            "id" = "photonfadein_start",
            "type" = "integerliteral",
            "value" = #75#,
        },
        {
            "id" = "photonfadein_end",
            "type" = "integerliteral",
            "value" = #105#,
        },
        $ fades end
    ],
    "inputresources" : [
        {
            "id" = "black"
            "file" = "black.png",
            "type" = "image",
            "width" = #1920#,
            "height" = #1080#,
        },
        {
            "id" = "bg"
            "file" = "sunny.png",
            "type" = "image",
            "width" = #1920#,
            "height" = #1080#,
        },
        {
            "id" = "co2"
            "file" = "co2.png",
            "type" = "image",
            "width" = #244#,
            "height" = #70#,
        },
        {
            "id" = "red"
            "file" = "photon_red.png",
            "type" = "image",
            "width" = #193#,
            "height" = #188#,
        },
        {
            "id" = "green"
            "file" = "photon_green.png",
            "type" = "image",
            "width" = #193#,
            "height" = #188#,
        },
        {
            "id" = "blue"
            "file" = "photon_blue.png",
            "type" = "image",
            "width" = #193#,
            "height" = #188#,
        },
        {
            "id" = "uv"
            "file" = "photon_purple.png",
            "type" = "image",
            "width" = #193#,
            "height" = #188#,
        },
    ],
    "outputfilespecs" : [
        {
            "id" = "frameout",
            "prefix" = "frame",
            "fileframemask" = "%04d",
            "suffix" = ".png",
        }
    ],
    "scene" : {
        "nodes" : [
            {
                "id" = "black",
                "type" = "constantimage",
                "res" = "black",
            },
            {
                "id" = "bg",
                "type" = "constantimage",
                "res" = "bg",
            },
            {
                "id" = "bgcomp",
                "type" = "imagecomposition",
            },
            {
                "id" = "bgfadein",
                "type" = "easing",
                "func" = "linear",
                "framestartref" = "zero",
                "frameendref" = "bgfadein_end",
                "initialvalueref" = "zero",
                "finalvalueref" = "one",
            },
            $ co2 start
            {
                "id" = "co2",
                "type" = "constantimage",
                "res" = "co2",
            },
            {
                "id" = "__tmp1_co2rot",
                "type" = "framecounter",
            },
            {
                "id" = "__tmp2_co2rot",
                "type" = "constantinteger",
                "ref" = "phaseoffset_co2",
            },
            {
                "id" = "__tmp3_co2rot",
                "type" = "numericbifunction",
                "func" = "+",
            },
            {
                "id" = "__tmp4_co2rot",
                "type" = "constantfloat",
                "ref" = "radperiod",
            },
            {
                "id" = "__tmp5_co2rot",
                "type" = "numericbifunction",
                "func" = "*",
            },
            {
                "id" = "co2rot",
                "type" = "numericmonofunction",
                "func" = "sin()",
            },
            $ 1co2
            {
                "id" = "1co2.fit",
                "type" = "imagefitter",
            },
            {
                "id" = "1co2.x",
                "type" = "constantinteger",
                "ref" = "s1co2.x",
            },
            {
                "id" = "1co2.y",
                "type" = "constantinteger",
                "ref" = "s1co2.y",
            },
            {
                "id" = "1co2.comp",
                "type" = "imagecomposition",
            },
            $ 2co2
            {
                "id" = "2co2.fit",
                "type" = "imagefitter",
            },
            {
                "id" = "2co2.x",
                "type" = "constantinteger",
                "ref" = "s2co2.x",
            },
            {
                "id" = "2co2.y",
                "type" = "constantinteger",
                "ref" = "s2co2.y",
            },
            {
                "id" = "2co2.comp",
                "type" = "imagecomposition",
            },
            $ 3co2
            {
                "id" = "3co2.fit",
                "type" = "imagefitter",
            },
            {
                "id" = "3co2.x",
                "type" = "constantinteger",
                "ref" = "s3co2.x",
            },
            {
                "id" = "3co2.y",
                "type" = "constantinteger",
                "ref" = "s3co2.y",
            },
            {
                "id" = "3co2.comp",
                "type" = "imagecomposition",
            },
            $ 4co2
            {
                "id" = "4co2.fit",
                "type" = "imagefitter",
            },
            {
                "id" = "4co2.x",
                "type" = "constantinteger",
                "ref" = "s4co2.x",
            },
            {
                "id" = "4co2.y",
                "type" = "constantinteger",
                "ref" = "s4co2.y",
            },
            {
                "id" = "4co2.comp",
                "type" = "imagecomposition",
            },
            $ 5co2
            {
                "id" = "5co2.fit",
                "type" = "imagefitter",
            },
            {
                "id" = "5co2.x",
                "type" = "constantinteger",
                "ref" = "s5co2.x",
            },
            {
                "id" = "5co2.y",
                "type" = "constantinteger",
                "ref" = "s5co2.y",
            },
            {
                "id" = "5co2.comp",
                "type" = "imagecomposition",
            },
            {
                "id" = "co2fadein",
                "type" = "easing",
                "func" = "linear",
                "framestartref" = "co2fadein_start",
                "frameendref" = "co2fadein_end",
                "initialvalueref" = "zero",
                "finalvalueref" = "one",
            },
            $ co2 end
        ],
        "links" : [
            $ co2
            {
                "outref" = "__tmp1_co2rot",
                "outport" = "out",
                "inref" = "__tmp3_co2rot",
                "inport" = "arg1",
            },
            {
                "outref" = "__tmp2_co2rot",
                "outport" = "out",
                "inref" = "__tmp3_co2rot",
                "inport" = "arg2",
            },
            {
                "outref" = "__tmp3_co2rot",
                "outport" = "out",
                "inref" = "__tmp5_co2rot",
                "inport" = "arg1",
            },
            {
                "outref" = "__tmp4_co2rot",
                "outport" = "out",
                "inref" = "__tmp5_co2rot",
                "inport" = "arg2",
            },
            {
                "outref" = "__tmp5_co2rot",
                "outport" = "out",
                "inref" = "co2rot",
                "inport" = "in",
            },
            $ bg
            {
                "outref" = "black",
                "outport" = "out",
                "inref" = "bgcomp",
                "inport" = "bg",
            },
            {
                "outref" = "bgfadein",
                "outport" = "out",
                "inref" = "bgcomp",
                "inport" = "alpha",
            },
            {
                "outref" = "bg",
                "outport" = "out",
                "inref" = "bgcomp",
                "inport" = "fg",
            },
            $ 1co2
            {
                "outref" = "bgcomp",
                "outport" = "out",
                "inref" = "1co2.comp",
                "inport" = "bg",
            },
            {
                "outref" = "co2",
                "outport" = "out",
                "inref" = "1co2.fit",
                "inport" = "in",
            },
            {
                "outref" = "co2rot",
                "outport" = "out",
                "inref" = "1co2.fit",
                "inport" = "rot",
            },
            {
                "outref" = "1co2.x",
                "outport" = "out",
                "inref" = "1co2.fit",
                "inport" = "xpos",
            },
            {
                "outref" = "1co2.y",
                "outport" = "out",
                "inref" = "1co2.fit",
                "inport" = "ypos",
            },
            {
                "outref" = "1co2.fit",
                "outport" = "out",
                "inref" = "1co2.comp",
                "inport" = "fg",
            },
            {
                "outref" = "co2fadein",
                "outport" = "out",
                "inref" = "1co2.comp",
                "inport" = "alpha",
            },
            $ 2co2
            {
                "outref" = "1co2.comp",
                "outport" = "out",
                "inref" = "2co2.comp",
                "inport" = "bg",
            },
            {
                "outref" = "co2",
                "outport" = "out",
                "inref" = "2co2.fit",
                "inport" = "in",
            },
            {
                "outref" = "2co2.x",
                "outport" = "out",
                "inref" = "2co2.fit",
                "inport" = "xpos",
            },
            {
                "outref" = "2co2.y",
                "outport" = "out",
                "inref" = "2co2.fit",
                "inport" = "ypos",
            },
            {
                "outref" = "2co2.fit",
                "outport" = "out",
                "inref" = "2co2.comp",
                "inport" = "fg",
            },
            {
                "outref" = "co2fadein",
                "outport" = "out",
                "inref" = "2co2.comp",
                "inport" = "alpha",
            },
            $ 3co2
            {
                "outref" = "2co2.comp",
                "outport" = "out",
                "inref" = "3co2.comp",
                "inport" = "bg",
            },
            {
                "outref" = "co2",
                "outport" = "out",
                "inref" = "3co2.fit",
                "inport" = "in",
            },
            {
                "outref" = "3co2.x",
                "outport" = "out",
                "inref" = "3co2.fit",
                "inport" = "xpos",
            },
            {
                "outref" = "3co2.y",
                "outport" = "out",
                "inref" = "3co2.fit",
                "inport" = "ypos",
            },
            {
                "outref" = "3co2.fit",
                "outport" = "out",
                "inref" = "3co2.comp",
                "inport" = "fg",
            },
            {
                "outref" = "co2fadein",
                "outport" = "out",
                "inref" = "3co2.comp",
                "inport" = "alpha",
            },
            $ 4co2
            {
                "outref" = "3co2.comp",
                "outport" = "out",
                "inref" = "4co2.comp",
                "inport" = "bg",
            },
            {
                "outref" = "co2",
                "outport" = "out",
                "inref" = "4co2.fit",
                "inport" = "in",
            },
            {
                "outref" = "4co2.x",
                "outport" = "out",
                "inref" = "4co2.fit",
                "inport" = "xpos",
            },
            {
                "outref" = "4co2.y",
                "outport" = "out",
                "inref" = "4co2.fit",
                "inport" = "ypos",
            },
            {
                "outref" = "4co2.fit",
                "outport" = "out",
                "inref" = "4co2.comp",
                "inport" = "fg",
            },
            {
                "outref" = "co2fadein",
                "outport" = "out",
                "inref" = "4co2.comp",
                "inport" = "alpha",
            },
            $ 5co2
            {
                "outref" = "4co2.comp",
                "outport" = "out",
                "inref" = "5co2.comp",
                "inport" = "bg",
            },
            {
                "outref" = "co2",
                "outport" = "out",
                "inref" = "5co2.fit",
                "inport" = "in",
            },
            {
                "outref" = "5co2.x",
                "outport" = "out",
                "inref" = "5co2.fit",
                "inport" = "xpos",
            },
            {
                "outref" = "5co2.y",
                "outport" = "out",
                "inref" = "5co2.fit",
                "inport" = "ypos",
            },
            {
                "outref" = "5co2.fit",
                "outport" = "out",
                "inref" = "5co2.comp",
                "inport" = "fg",
            },
            {
                "outref" = "co2fadein",
                "outport" = "out",
                "inref" = "5co2.comp",
                "inport" = "alpha",
            },
        ],
        "outputs" : [
            {
                "type" = "image",
                "filespecref" = "frameout",
                "outref" = "5co2.comp",
                "outport" = "out",
            },
        ],
    },
},